<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:template="http://www.boddie.org.uk/ns/xmltools/template"
                version="1.0">

  <xsl:param name="categories"/>

  <xsl:template match="categories">
    <xsl:copy>
      <xsl:element name="category">
        <xsl:variable name="category-elements" select="category"/>
        <xsl:for-each select="$categories/category/category-enum">
          <xsl:variable name="category-enum" select="."/>
          <xsl:copy>
            <xsl:apply-templates select="@*"/>
            <xsl:if test="$category-elements[@value = $category-enum/@value]">
              <xsl:attribute name="value-is-set">true</xsl:attribute>
            </xsl:if>
          </xsl:copy>
        </xsl:for-each>
      </xsl:element>
    </xsl:copy>
  </xsl:template>

  <!-- Replicate unknown elements. -->

  <xsl:template match="@*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>
